; BMP loader for Tasm 4.0 / WDosX 0.96
; By Mic, 2000
;
; How to use:
;
;  set edx = pointer to ASCIIZ filename
;  set esi = pointer to BITMAP struct
;  call load_bmp...
;
; !note! Only works with 8-bit images at the moment.


;INT read8bit(VOID)
; value[_read8bit]
read8bit PROC
 mov _read8bit,1
 mov eax,bpr_
 sub eax,bih30_xdim
 mov padding,eax
 mov ecx,0
 mov bx,BMPfile
 mov edi,dummy4
 add edi,18
 read8bit_@get_pal:
  mov ecx,numcolors
  ;dec ecx
  cmp bfh_ihsize,40
  jne read8bit_@no_rgbx
   shl ecx,2
   jmp read8bit_@gimme
  read8bit_@no_rgbx:
   mov ecx,[ecx*2 + ecx]
  read8bit_@gimme:
  mov bx,BMPfile
  mov edx,OFFSET dummypal
  call fread
  mov ecx,0
  mov esi,OFFSET dummypal
  read8bit_@sort_pal:
   lodsb
   shr al,2
   mov ds:[edi + 2],al
   lodsb
   shr al,2
   mov ds:[edi + 1],al
   lodsb
   shr al,2
   mov ds:[edi],al
   add edi,3
   cmp bfh_ihsize,40
   jne read8bit_@no_rgbx_2
    lodsb
   read8bit_@no_rgbx_2:
   inc ecx
   cmp ecx,numcolors
  jne read8bit_@sort_pal
 mov eax,bih30_xdim
 mov ebx,bih30_ydim
 mul ebx
 sub eax,bih30_xdim
 mov edx,eax
 add edx,BMPmem
 mov ecx,0
 read8bit_@get_data:
  mov bx,BMPfile
  push ecx
  mov ecx,bih30_xdim
  call fread
  pop ecx
  cmp padding,0
  jng read8bit_@no_padding
   push ecx
   push edx
   mov edx,OFFSET BMPjunk
   mov ecx,padding
   call fread
   pop edx
   pop ecx
  read8bit_@no_padding:
  sub edx,bih30_xdim
  inc ecx
  cmp ecx,bih30_ydim
 jne read8bit_@get_data
 mov _read8bit,0
 ret
read8bit ENDP
 


;INT load_bmp(CHAR *filename,BITMAP *bp)
; parm[edx][esi]
; value[eax] 
;(returns 0 on success, 1 - 4 on failure (see errorcodes in .data section))	
load_bmp PROC
 mov al,0		;|
 call fopen		;| open file using access mode 0 (rw. ..or something..)
 cmp bx,0		
 jne load_bmp_@ok1
  mov eax,BMPFileError
  ret
 load_bmp_@ok1:
 mov BMPfile,bx
 mov dummy4,esi
 mov edx,OFFSET BMPFILEHEADER
 mov ecx,18
 call fread
 cmp ecx,18
 je load_bmp_@ok2
  mov bx,BMPfile
  call fclose
  mov eax,BMPFileError
  ret
 load_bmp_@ok2:
 cmp bfh_header,19778		;19778="BM" (standard BMP header)
 je load_bmp_@ok3
  mov bx,BMPfile
  call fclose
  mov eax,BMPFormatError
  ret
 load_bmp_@ok3:
 cmp bfh_ihsize,40
 jne load_bmp_@elsif_bmp20
 mov edx,OFFSET BMPINFOHEADER30	;it's a BMP v. 3.0(+)
 mov ecx,36
 mov bx,BMPfile
 call fread
 cmp ecx,36
 je load_bmp_@ok4
  mov bx,BMPfile
  call fclose
  mov eax,BMPFileError
  ret
 load_bmp_@ok4:
 mov eax,bfh_offsbits
 sub eax,bfh_ihsize		;\
 sub eax,14			; |
 shr eax,2			; | numcolors=(bfh.offsbits-bfh.ihsize-14)/4
 mov numcolors,eax		;/	
 jmp load_bmp_@got_ih
 load_bmp_@elsif_bmp20:
 cmp bfh_ihsize,12
 jne load_bmp_@bmp_unknown	;unsupported format
 mov edx,OFFSET BMPINFOHEADER20	;it's a BMP v. 2.0
 mov ecx,8
 mov bx,BMPfile
 call fread
 cmp ecx,8
 je load_bmp_@ok5
  mov bx,BMPfile
  call fclose
  mov eax,BMPFileError
  ret
 load_bmp_@ok5:
 xor eax,eax
 mov ax,bih20_xdim
 mov bih30_xdim,eax
 mov ax,bih20_ydim
 mov bih30_ydim,eax
 mov ax,bih20_planes
 mov bih30_planes,ax
 mov ax,bih20_bitcount
 mov bih30_bitcount,ax
 mov eax,bfh_offsbits
 sub eax,bfh_ihsize		;\
 sub eax,14			; \
 mov ebx,3			;  | numcolors=(bfh.offsbits-bfh.ihsize-14)/3
 cwd				;
 div ebx			; /
 mov numcolors,eax		;/	
 jmp load_bmp_@got_ih
 load_bmp_@bmp_unknown:
  mov bx,BMPfile
  call fclose
  mov eax,BMPFormatError
  ret
 load_bmp_@got_ih:
 xor eax,eax
 mov ax,bih30_bitcount		;\
 mov ebx,bih30_xdim		; \
 mul ebx			;  |
 add eax,31			;  | bpr=(((bitcount*width)+31) >> 5) << 2
 shr eax,5			;  |
 shl eax,2			; /
 mov bpr_,eax			;/
 cmp bih30_bitcount,8
 jne load_bmp_@bpp_error
  mov eax,bih30_xdim
  mov ebx,bih30_ydim
  mul ebx
  call malloc
  cmp edi,0
  jne load_bmp_@mem_ok1
   mov bx,BMPfile
   call fclose
   mov eax,BMPMemoryError
   ret
  load_bmp_@mem_ok1:
  mov BMPmem,edi
  mov BMPmemH,ebx
  call read8bit
  mov bx,BMPfile
  call fclose
  mov edi,dummy4
  mov eax,bih30_xdim
  mov ds:[edi],eax
  mov eax,bih30_ydim
  mov ds:[edi + 4],eax
  mov eax,BMPmem
  mov ds:[edi + 8],eax
  mov eax,BMPmemH
  mov ds:[edi + 12],eax
  mov ax,bih30_bitcount
  mov ds:[edi + 16],ax
  mov eax,_read8bit
  ret
 load_bmp_@bpp_error:
 mov bx,BMPfile
 call fclose
 mov eax,BMPFormatError
 ret
load_bmp ENDP


include malloc.inc
include file.inc


.data
 BMPOk			EQU 0
 BMPFileError 		EQU 1
 BMPFormatError 	EQU 2
 BMPBitCountError	EQU 3
 BMPMemoryError		EQU 4
 PALETTE		EQU <db 768 DUP(?)>

 BMPFILEHEADER label byte
  bfh_header		dw 0
  bfh_size		dd 0
  bfh_resv1		dw 0
  bfh_resv2		dw 0
  bfh_offsbits		dd 0
  bfh_ihsize		dd 0

 BMPINFOHEADER30 label byte
  bih30_xdim		dd 0
  bih30_ydim		dd 0
  bih30_planes		dw 0
  bih30_bitcount	dw 0
  bih30_compressed	dd 0
  bih30_imgsize		dd 0
  bih30_xpelspermeter	dd 0
  bih30_ypelspermeter	dd 0
  bih30_clrsused	dd 0
  bih30_clrsimportant	dd 0
	
 BMPINFOHEADER20 label byte
  bih20_xdim		dw 0
  bih20_ydim		dw 0
  bih20_planes		dw 0
  bih20_bitcount	dw 0

 _read8bit	dd 0
 _read24bit	dd 0

 BMPfile	FILE 0
 BMPmem		dd 0
 BMPmemH	dd 0
 numcolors	dd 0
 bpr_		dd 0	;Bytes Per Row
 padding	dd 0	;..rows are always aligned on 4 bytes

 dummy1		db 0
 dummy2		dw 0
 dummy4		dd 0
 BMPjunk	db 10 DUP(?)
 dummypal	db 1024 DUP(?)


;(STRUCTs must come last or the EXE-file will get screwed up..)

 BITMAP STRUC
  bmp_xdim	dd ?		;width of bitmap
  bmp_ydim	dd ?		;height of bitmap
  bmp_pointer	dd ?		;pointer to image data
  bmp_handle	dd ?		;handle of the same memory, for use with free()
  bmp_bpp	dw ?		;bytes per pixel 
  bmp_palette	PALETTE		;a length-768 array of bytes 
 BITMAP ENDS
