; Cache-optimized RotoZoom effect with optional antialiasing for Tasm (4.0) / WdosX (0.96)
; By Mic, 2000
;
; How to compile:
;
;  tasm /m rzoom.asm
;  tlink32 rzoom.obj
;  stubit rzoom.exe
;
; ! DO NOT COMPILE WITH ANY VERSION OF TASM PRIOR TO 4.0 !
;   Even though both Tasm/Tlink32 & Stubit says everything's fine, the program
;   might still crash your system and force you to do a hard reboot..
;
; This effect is based on the program BITMAP.PAS by Paul H. Kahler, 1994.
; The BilinearAntialias routine was orginally written by Lewis A. Sellers, 1995/1996. Ported to Asm by Mic, 2000.
;
; A description of the tiling-scheme can be found in FATMAP2.TXT by MRI/Doomsday.
;



.486
.model flat
.code



;VOID MakeTables(VOID)
MakeTables PROC
 mov ecx,0
 MT_@loop:
  mov angle,ecx
  fild dword ptr [angle]		;\
  fld qword ptr [vfix]			; angle*=vfix
  fmul					; /
  fstp qword ptr [angle2]		;/
  fld qword ptr [angle2]		;\
  fsin					; \
  fld qword ptr [twofiftysix]		;  sinTb[ecx]=(sin(angle) << 8) 
  fmul					; /
  fistp dword ptr [sinTb + ecx*4]	;/
  fld qword ptr [angle2]		;\
  fcos					; \
  fld qword ptr [twofiftysix]		;  cosTb[ecx]=(cos(angle) << 8)
  fmul					; /
  fistp dword ptr [cosTb + ecx*4]	;/	
  fld qword ptr [angle2]		;\
  fld qword ptr [vfix2]			; \
  fadd    				;  \
  fsin					;   \
  fld qword ptr [twofiftysix]		;    sinTb2[ecx]=(sin(angle+vfix2) << 8)*1.2
  fmul					;   /
  fld qword ptr [onepointtwo]		;  /
  fmul					; /
  fistp dword ptr [sinTb2 + ecx*4]	;/
  fld qword ptr [angle2]		;\
  fld qword ptr [vfix2]			; \
  fadd					;  \
  fcos					;   \
  fld qword ptr [twofiftysix]		;    cosTb2[ecx]=(cos(angle+vfix2) << 8)*1.2
  fmul					;   /
  fld qword ptr [onepointtwo]		;  /
  fmul					; /
  fistp dword ptr [cosTb2 + ecx*4]	;/
  inc ecx
  cmp ecx,256
 jne MT_@loop
 ret
MakeTables ENDP


;UINT TileTexture(BITMAP *bmpPtr)
; parm[edx]
; value[eax]	(0=success, 1=failure)
TileTexture PROC
local TTptr:dword, TThnd:dword, TTu:dword, TTv:dword
 push edx
 mov eax,65536
 call malloc
 cmp edi,0
 jne TT_@malloc_ok
  mov eax,1
  ret
 TT_@malloc_ok:
 mov TTptr,edi
 mov TThnd,ebx
 pop edx
 mov esi,[edx + 8]	;grab pointer
 mov TTv,0
 TT_@vloop:
  mov TTu,0
  TT_@uloop:
   mov eax,TTu		;\
   shl eax,8		; \
   and eax,0F800h	;  \	 
   mov ebx,TTu		;   \
   and ebx,7		;    \
   add eax,ebx		;    dest_offset=((u << 8) & 0xF800)+(u & 7)+((v << 3) & 0x7F8) 
   mov ebx,TTv		;   /
   shl ebx,3		;  /
   and ebx,07F8h	; /
   add ebx,eax		;/
   mov ecx,TTv
   shl ecx,8
   add ecx,TTu
   mov al,[esi + ecx]
   mov [edi + ebx],al
   inc TTu
   cmp TTu,256
  jne TT_@uloop
  inc TTv
  cmp TTv,256
 jne TT_@vloop
 mov ebx,[edx + 12]
 call free
 mov eax,TTptr
 mov ebx,TThnd
 mov [edx + 8],eax	;store new pointer
 mov [edx + 12],ebx	; -"-  new handle
 mov eax,0
 ret
TileTexture ENDP


;VOID RotoZoom(VOID *src,VOID *dest)
; parm[esi][edi]
RotoZoom PROC
 pusha
 mov eax,tildudx
 mov ebp,eax
 mov edx,eax 
 shl eax,8
 and eax,4160749568
 shr ebp,1
 and ebp,32767
 and edx,458752
 add eax,ebp
 add eax,edx
 or eax,133726208
 mov tildudx,eax
 mov eax,tildvdx
 mov ebp,eax
 shl eax,3
 and eax,133693440
 shr ebp,1
 and ebp,32767
 add eax,ebp
 or eax,4161241088
 mov tildvdx,eax
 xor ebx,ebx
 mov ecx,200 
 RZ_@vLoop:
  push ecx
  push edi
  mov ebp,i
  mov eax,ebp
  mov ecx,ebp 
  shl ebp,8
  shr eax,1
  and ebp,4160749568
  and eax,32767
  and ecx,458752
  add ebp,eax
  add ebp,ecx
  mov edx,j
  mov eax,edx
  shl edx,3 
  shr eax,1
  and edx,133693440
  and eax,32767
  mov ebx,eax
  add ebx,edx
  mov ecx,320
  add edi,319
  xor ecx,-1
  add ecx,2		; only draw 319 pixels per scanline, or the program will cause a GPF (ack..)
  lea eax,[ebx + ebp]
  RZ_@inner:
   add ebp,tildudx
   add ebx,tildvdx
   shr eax,16
   and ebp,4161241087	; 11111000 00000111 01111111 11111111
   and ebx,133726207	; 00000111 11111000 01111111 11111111
   mov dl,[esi + eax]
   mov [edi + ecx],dl
   lea eax,[ebp + ebx]
   inc ecx
  jnz RZ_@inner
  mov eax,i
  add eax,tildudx_2
  mov i,eax
  mov eax,j
  add eax,tildvdx_2
  mov j,eax
  pop edi
  add edi,320
  pop ecx
  dec ecx
  jz RZ_@done
 jmp RZ_@vloop
 RZ_@done:
 popa
 ret
RotoZoom ENDP


;VOID DrawScreen(VOID *dest,VOID *src,UINT x,UINT y,INT scale,INT rot)
; parm[edi][esi][eax][ebx][ecx][edx]
DrawScreen PROC
local DSx:dword, DSy:dword, DSscale:dword, DSrot:dword
 mov DSx,eax
 mov DSy,ebx
 mov DSscale,ecx
 mov DSrot,edx
 mov eax,[cosTb + edx*4]
 imul DSscale
 sar eax,8
 mov tildudx,eax
 mov edx,DSrot
 mov eax,[sinTb + edx*4]
 imul DSscale
 sar eax,8
 mov tildvdx,eax
 mov edx,DSrot
 mov eax,[cosTb2 + edx*4]
 imul DSscale
 sar eax,8
 mov tildudx_2,eax
 mov edx,DSrot
 mov eax,[sinTb2 + edx*4]
 imul DSscale
 sar eax,8
 mov tildvdx_2,eax
 mov eax,160
 imul tildudx
 mov ebx,eax
 mov eax,100
 imul tildudx_2
 mov ecx,eax
 mov eax,DSx
 sub eax,ebx
 sub eax,ecx
 sal eax,8
 mov i,eax
 mov eax,160
 imul tildvdx
 mov ebx,eax
 mov eax,100
 imul tildvdx_2
 mov ecx,eax
 mov eax,DSy
 sub eax,ebx
 sub eax,ecx
 sal eax,8
 mov j,eax
 sal tildudx,8
 sal tildudx_2,8
 sal tildvdx,8
 sal tildvdx_2,8
 call RotoZoom
 ret
DrawScreen ENDP


;VOID BilinearAntialias(VOID *dest,VOID *mixtable)
; parm [edi][esi]
BilinearAntialias PROC
 add edi,321 
 mov ecx,198 
 BiLin_yloop:
  push ecx 
  mov ecx,318
  BiLin_xloop:
   xor eax,eax
   mov ah,[edi - 1]
   mov al,[edi + 320] 
   mov al,[esi + eax] 
   mov ah,[edi + 1] 
   mov al,[esi + eax] 
   mov ah,[edi - 320] 
   mov al,[esi + eax] 
;    mov ah,[edi + 321] 		; uncomment these lines to get trilinear antialiasing (sloooow)
;    mov al,[esi + eax] 
;    mov ah,[edi - 321] 
;    mov al,[esi + eax]
;    mov ah,[edi + 319]
;    mov al,[esi + eax]
;    mov ah,[edi - 319]
;    mov al,[esi + eax]
   mov ah,[edi]
   mov al,[esi + eax]
   stosb
   dec cx
  jnz BiLin_xloop
  pop ecx
  add edi,2 
  dec cx
 jnz BiLin_yloop
 ret
BilinearAntialias ENDP



;UCHAR ParseInput(VOID *argv,VOID *szParams,INT argc)
; parm[esi][edx][eax]
; value[al]
ParseInput PROC
local parmFlags:byte, len1:dword, len2:dword, match:byte, _params:dword, ptr1:dword, ptr2:dword
 mov parmFlags,0
 mov _params,eax
 mov ptr1,esi
 mov ptr2,edx
 mov ecx,0
 PI_@loop:
  push ecx
  mov edx,ptr1
  mov edi,[edx + ecx*4]
  mov al,0
  mov ecx,255
  repne scasb
  inc ecx
  mov len1,255
  sub len1,ecx
  mov edi,ptr2
  mov al,0
  mov ecx,255
  repne scasb
  inc ecx
  mov len2,255
  sub len2,ecx
  mov eax,len2
  inc eax
  add ptr2,eax
  mov eax,len2
  cmp eax,len1
  jne PI_@next
  mov edx,ptr1
  mov edi,[edx + ecx*4]
  mov esi,ptr2
  sub esi,len2
  dec esi
  mov ecx,len1
  mov match,1
  PI_@compare:
   cmpsb
   jz PI_@compare_next
   mov match,0
   jmp PI_@compare_break
   PI_@compare_next:
   dec ecx
  jnz PI_@compare
  PI_@compare_break:
  cmp match,1
  jne PI_@next
  mov al,cl
  shl al,cl
  or parmFlags,al
  PI_@next:
  pop ecx
  inc ecx
  cmp ecx,_params
 jne PI_@loop
 mov al,parmFlags
 ret
ParseInput ENDP




;** MAIN code **
start:
mov argc,esi
mov argv,edi
push ds
pop es

cmp argc,1		;are there enough parameters ?
jg args_ok		;yep
 mov edx,OFFSET sHowTo	;nooo
 mov ah,9
 int 21h
 mov al,1
 call abort
args_ok:

mov edx,OFFSET sStartUpMsg
mov ah,9
int 21h
call GetKey
call Cls

mov eax,129536			;allocate 64000 + 65536 bytes of memory
call malloc
cmp edi,NULL			;out of memory already ?
jne malloc_ok			;nah
 mov edx,OFFSET sMemFailure	;yes indeed
 mov ah,9
 int 21h
 mov al,1
 call abort			;abort, abort, abo..
malloc_ok:
mov mHnd,ebx
mov vscreen,edi
mov mixxx,edi
add mixxx,64000


mov edx,OFFSET sInit1
mov ah,9
int 21h
mov edi,argv			;put parameterstring-pointer in edi
mov edx,[edi + 4]		;edx = OFFSET parameter #1 (parameter #0 = EXEname)
mov esi,OFFSET piccy
call load_bmp			;load texture
cmp eax,0			;any errors ?
je load_bmp_ok			;nope
 mov [Printf_params],eax
 mov edx,OFFSET sBMPFailure1
 mov ah,9
 int 21h
 mov edx,argv
 mov edi,[edx + 4]
 call Asciiz2Tasm_		;convert zero-terminated string to '$'-terminated string
 mov edi,argv
 mov edx,[edi + 4]
 mov ah,9
 int 21h
 mov edx,OFFSET sBMPFailure2
 mov Printf_strPtr,edx
 mov Printf_numParams_,1
 call Printf
 mov al,1			
 call abort
load_bmp_ok:

cmp piccy.bmp_xdim,256
je bmp_xdim_ok
 mov edx,OFFSET sBMPFailure3
 mov ah,9
 int 21h
 mov al,1
 call abort
bmp_xdim_ok:
cmp piccy.bmp_ydim,256
je bmp_ydim_ok
 mov edx,OFFSET sBMPFailure3
 mov ah,9
 int 21h
 mov al,1
 call abort
bmp_ydim_ok:
cmp piccy.bmp_bpp,8
je bmp_bpp_ok
 mov edx,OFFSET sBMPFailure4
 mov ah,9
 int 21h
 mov al,1
 call abort
bmp_bpp_ok:

mov edx,OFFSET sDone
mov ah,9
int 21h


mov edx,OFFSET sInit2
mov ah,9
int 21h
mov edx,OFFSET piccy
call TileTexture
cmp eax,0
je tile_ok
 mov edx,OFFSET sTTFailure
 mov ah,9
 int 21h
 mov edx,OFFSET sProbMem
 mov ah,9
 int 21h
 mov al,1
 call abort
tile_ok:
mov edx,OFFSET sDone
mov ah,9
int 21h

mov edx,OFFSET sInit3
mov ah,9
int 21h
call MakeTables
mov edx,OFFSET sDone
mov ah,9
int 21h

mov esi,OFFSET piccy.bmp_palette	;\
mov al,0				; \
mov [esi],al				;  set color 0 to black
mov [esi+1],al				; /
mov [esi+2],al				;/

mov edx,OFFSET sInit4
mov ah,9
int 21h
mov edi,mixxx				;\		
mov ebx,OFFSET piccy.bmp_palette	; \	
mov edx,OFFSET piccy.bmp_palette	;  create a mixtable. mix the palette with itself 	
mov esi,OFFSET piccy.bmp_palette        ; / 	           		 
call create_mixtable			;/
mov edx,OFFSET sDone			
mov ah,9
int 21h

mov eax,19				
call gfx_mode				;set graphics mode 19 (320*200*256)
mov esi,OFFSET piccy.bmp_palette
call set_pal				;set palette


mov edi,vscreen				;\
mov eax,0				; \
mov ecx,16000				; clear vscreen
rep stosd				;/

call tmInit				;initialize timer
call tmGetTimer				;|	
mov stime,eax				;| get starting time

;** MAIN loop **
main_loop:
 in al,60h
 mov key,al
 cmp al,scan_A
 jne main_@elsif_key_S
  mov antialiasing,1
  jmp main_@endif_key
 main_@elsif_key_S:
 cmp al,scan_S
 jne main_@endif_key
  mov antialiasing,0
 main_@endif_key:
 mov esi,piccy.bmp_pointer
 mov edi,vscreen
 mov eax,rotX
 mov ebx,rotY
 mov ecx,dist
 mov edx,rot2
 call DrawScreen
 cmp antialiasing,1
 jne main_@no_antialiasing
  mov edi,vscreen
  mov esi,mixxx
  call BilinearAntialias
 main_@no_antialiasing:
 call wait_vrt
 mov esi,vscreen		;\ 
 mov edi,_VGA_			; copy offscreen buffer to video memory (0A0000h)
 call copy_screen		;/
 inc frames
 add rotY,128
 mov eax,d_r
 add rot2,eax
 mov eax,d_d
 add dist,eax
 and dist,0FFFFh
 cmp dist,25
 jg elsif_dist_max
 neg d_d
 elsif_dist_max:
 cmp dist,1200
 jnge endif_dist
 neg d_d
 endif_dist:
 and rot2,0FFh
 mov al,key
 cmp al,scan_Esc
jne main_loop

call tmGetTimer			;|
mov etime,eax			;| get ending time
call tmClose			;remove timer

mov ebx,mHnd
call free
mov ebx,piccy.bmp_handle
call free
mov eax,3
call gfx_mode

;<Print FPS>
mov edx,OFFSET sEndMsg
mov Sprintf__strPtr,edx
mov eax,etime
sub eax,stime
call tmSecondsf			;convert ticks to seconds
mov i,eax
fild dword ptr [frames]
fld dword ptr [i]
fdiv				;calculate frames/second
fst dword ptr [Sprintf__params]
mov Sprintf__numParams_,1	;signal that there is (at least) one parameter	
call Sprintf_			;convert formatted string
mov edx,OFFSET sysStr01_	;string ends up in sysStr01_ (from core.inc)
mov ah,DOS_WRITE_STRING
int DOS_FUNCTION		;print it
;</Print FPS>

mov al,0
call abort


include core.inc
include stdlib.inc
include xix.inc
include timer.inc
include bmp.inc
include colors.inc

.data
 scan_A		equ 30
 scan_S		equ 31
 scan_Esc	equ 1

 mHnd		UINT ?			;memory-handle
 vscreen	UINT ?			;pointer to offscreen buffer
 mixxx		UINT ?			;   --"--   mixtable

 sinTb		UINT 256 DUP (?)	;\
 cosTb		UINT 256 DUP (?)	; some trigonometric tables
 sinTb2		UINT 256 DUP (?)	; /
 cosTb2		UINT 256 DUP (?)	;/	

 argc		UINT ?
 argv		UINT ?

 antialiasing	CHAR 0
 key		CHAR 0

 rotX		dd 32768
 rotY		dd 0
 rot2		dd 1
 d_r		dd 1
 dist		dd 1000
 d_d		dd 65527
		
 i		dd ?
 j		dd ?
 tildudx	dd ?
 tildvdx	dd ?
 tildudx_2	dd ?
 tildvdx_2	dd ?

 frames		UINT 0			;number of frames drawn
 stime		UINT ?			;starting time
 etime		UINT ?			;ending time

 vfix		DOUBLE 0.024544		;PI/128
 vfix2		DOUBLE 1.570796		;PI/2
 onepointtwo	DOUBLE 1.200
 twofiftysix	DOUBLE 256.00
 angle		SINGLE ?
 angle2		DOUBLE ?

 sStartUpMsg 	CHAR 'Cache-optimized RotoZoomer for Tasm/WDosX by Mic.',13,10,13,10
 		CHAR 'Try the following keys:',13,10
		CHAR ' [a]:   Turn bilinear antialiasing ON',13,10
		CHAR ' [s]:   Turn bilinear antialiasing OFF',13,10
		CHAR ' [Esc]: Exit program',13,10
		CHAR 13,10,'Press any key...','$'
 sHowTo		CHAR 'Syntax: RZOOM.EXE filename.bmp',13,10,13,10
		CHAR '(Image must be 256*256 8-bit color)',13,10,'$'
 sInit1		CHAR 'Loading texture..                ','$'
 sInit2		CHAR 'Tiling texture..                 ','$'
 sInit3		CHAR 'Creating trigonometric tables..  ','$'
 sInit4		CHAR 'Creating mixtable..              ','$'
 sDone		CHAR 'DONE',13,10,'$'
 sMemFailure	CHAR 'Doh! Out of memory.'
 sBMPFailure1	CHAR 13,10,'Doh! Unable to load ','$'
 sBMPFailure2	CHAR ' (errorcode %d).','$'
 sBMPFailure3	CHAR 13,10,'Error: Image must be 256*256 in size.','$'
 sBMPFailure4	CHAR 13,10,'Error: Image must be an 8-bit BMP.','$'
 sTTFailure	CHAR 13,10,'Doh! procedure TileTexture() failed.','$'
 sProbMem	CHAR 13,10,'(probably out of memory)','$'
 sEndMsg	CHAR 'This program was running at %2f fps.\n','$'

 szParams	CHAR '-0',0
		CHAR '/0',0
		CHAR '-s',0
		CHAR '/s',0
 paramsFound	CHAR 0

 piccy		BITMAP <?>


end start

