

;VOID abort(UCHAR errorcode)
; parm[al]
abort PROC
 mov ah,DOS_TERMINATE_EXE
 int DOS_FUNCTION
abort ENDP


;[ VOID Print(DWORD value) ]
Print PROC
  push esi
  push edi
  mov eax,Print_value
  mov Sprint__value,eax
  mov edi,OFFSET sysStr01_
  call Sprint_
  mov edx,OFFSET sysStr01_
  mov ah,09h
  int 21h
  pop edi
  pop esi
  ret
Print ENDP


PrintHex_ PROC
  push esi
  push edi
  mov eax,PrintHex_value
  mov SprintHex__value,eax
  mov edi,OFFSET sysStr01_
  call SprintHex_
  mov edx,OFFSET sysStr01_
  mov ah,09h
  int 21h  
  pop edi
  pop esi
  ret
PrintHex_ ENDP


PrintBin_ PROC
  push esi
  push edi
  mov eax,PrintBin_value
  mov SprintBin__value,eax
  mov edi,OFFSET sysStr01_
  call SprintBin_
  mov edx,OFFSET sysStr01_
  mov ah,09h
  int 21h  
  pop edi
  pop esi
  ret
PrintBin_ ENDP


PrintFloat_ PROC
  push esi
  push edi
  mov eax,PrintFloat__value
  cmp eax,0
  je PrintFloat__@its_zero
  mov PrintFloat__subZero_,0
  mov ebx,eax
  and eax,080000000h
  cmp eax,0
  je PrintFloat__@above_zero
    mov PrintFloat__subZero_,1
  PrintFloat__@above_zero:
  mov eax,ebx
  and eax,7f800000h
  shr eax,23
  sub eax,127
  mov PrintFloat__exp_,al
  mov eax,ebx
  and eax,007fffffh
  mov PrintFloat__mantissa_,eax
  cmp PrintFloat__exp_,0
  jng PrintFloat__@test_exp_below_zero
    mov cl,PrintFloat__exp_
    mov eax,1
    shl eax,cl
    mov cl,23
    sub cl,PrintFloat__exp_
    mov edx,PrintFloat__mantissa_
    shr edx,cl				;shift mantissa by 23-exponent
    or eax,edx
    mov PrintFloat__int_,eax
    mov cl,PrintFloat__exp_
    mov eax,PrintFloat__mantissa_
    shl eax,cl				;throw away the bits that went into the integer part
    and eax,007fffffh			;only keep the 23 lower bits 
    mov PrintFloat__frac_,eax
  jmp PrintFloat__@exp_fix_done
    PrintFloat__@test_exp_below_zero:
    cmp PrintFloat__exp_,0
    jnl PrintFloat__@exp_fix_done
    mov PrintFloat__int_,0
    mov eax,PrintFloat__mantissa_
    shr eax,1
    or eax,00400000h
    mov cl,PrintFloat__exp_
    neg cl
    dec cl
    shr eax,cl
    mov PrintFloat__frac_,eax
  PrintFloat__@exp_fix_done:
  mov esi,OFFSET PrintFloat__str_
  cmp PrintFloat__subZero_,0
  je PrintFloat__@above_zero_2
    mov al,'-'
    mov [esi],al
  PrintFloat__@above_zero_2:
  inc esi
  ;*** convert fractional value ***
  mov cx,23
  mov eax,500000000		;pseudo for 0.500000000
  mov ebx,00400000h		;mask. begin at bit 23
  mov PrintFloat__fixedFrac_,0
  PrintFloat__@frac_fix:
    mov edx,PrintFloat__frac_
    and edx,ebx
    cmp edx,0
    je PrintFloat__@bit_not_set
    add PrintFloat__fixedFrac_,eax
    PrintFloat__@bit_not_set:
    shr eax,1
    shr ebx,1
    dec cx
  jnz PrintFloat__@frac_fix
  mov eax,PrintFloat__int_
  mov Print_value,eax
  call Print
  mov edx,OFFSET PrintFloat__dot_
  mov ah,09h
  int 21h
  mov eax,PrintFloat__fixedFrac_
  mov Print_value,eax
  call Print
  jmp PrintFloat__@return
  PrintFloat__@its_zero:
    mov edx,OFFSET PrintFloat__zeroStr_
    mov ah,09h
    int 21h
  PrintFloat__@return:
  pop edi
  pop esi
  ret
PrintFloat_ ENDP
   
 

;[ VOID Printf(DWORD strPtr,DWORD params) ]
Printf PROC
  push es
  mov ax,ds
  mov es,ax
  cmp Printf_numParams_,0
  jne Printf_@numParams_not_zero
  mov edx,Printf_strPtr
  mov ah,09h
  int 21h
  jmp Printf_@done
  Printf_@numParams_not_zero:
  mov al,'$'
  mov cx,255
  mov edi,Printf_strPtr
  repne scasb
  inc cx
  mov dx,255
  sub dl,cl
  mov Printf_strLen_,dl
  mov esi,Printf_strPtr
  mov Printf_lastStrPos_,esi
  mov Printf_strPos_,1
  mov ebx,OFFSET Printf_params
  mov Printf_paramPtr_,ebx
  Printf_@loop:
    mov al,[esi]
    cmp al,'%'
    jne Printf_@no_format_sign
    mov al,'$'
    mov [esi],al
    mov eax,esi
    sub eax,Printf_lastStrPos_
    jz Printf_@dont_print_this_1
    mov edx,Printf_lastStrPos_
    mov ah,09h
    int 21h
    Printf_@dont_print_this_1:
    inc esi
    mov al,[esi]
    inc esi
    Printf_@if_al_is_d:
      cmp al,'d'
      jne Printf_@elsif_al_is_percent
      mov ebx,Printf_paramPtr_
      add Printf_paramPtr_,4
      mov eax,ds:[ebx]
      mov Print_value,eax
      call Print
      jmp Printf_@endif_al_is_d
    Printf_@elsif_al_is_percent:
      cmp al,'%'
      jne Printf_@elsif_al_is_h
      mov bl,[esi]
      mov al,'$'
      mov [esi],al
      mov edx,esi
      dec edx
      mov ah,09h
      int 21h
      mov [esi],bl       
      jmp Printf_@endif_al_is_d
    Printf_@elsif_al_is_h:
      cmp al,'h'
      jne Printf_@elsif_al_is_b
      mov ebx,Printf_paramPtr_
      add Printf_paramPtr_,4
      mov eax,ds:[ebx]
      mov PrintHex_value,eax
      call PrintHex_
      jmp Printf_@endif_al_is_d
    Printf_@elsif_al_is_b:
      cmp al,'b'
      jne Printf_@elsif_al_is_f
      mov ebx,Printf_paramPtr_
      add Printf_paramPtr_,4
      mov eax,ds:[ebx]
      mov PrintBin_value,eax
      call PrintBin_
      jmp Printf_@endif_al_is_d
    Printf_@elsif_al_is_f:
      cmp al,'f'
      jne Printf_@endif_al_is_d
      mov ebx,Printf_paramPtr_
      add Printf_paramPtr_,4
      mov eax,ds:[ebx]
      mov PrintFloat__value,eax
      call PrintFloat_    
    Printf_@endif_al_is_d:
    mov Printf_lastStrPos_,esi
    add Printf_strPos_,2
    jmp Printf_@loop_next
    Printf_@no_format_sign:
    cmp al,'\'
    jne Printf_@no_escape_sign
    mov al,'$'
    mov [esi],al
    mov eax,esi
    sub eax,Printf_lastStrPos_
    jz Printf_@dont_print_this_2
    mov edx,Printf_lastStrPos_
    mov ah,09h
    int 21h
    Printf_@dont_print_this_2:
    inc esi
    mov al,[esi]
    inc esi
    Printf_@if_al_is_n:
      cmp al,'n'
      jne Printf_@elsif_al_is_backslash
      mov edx,OFFSET sysLF_
      mov ah,09h
      int 21h
      jmp Printf_@endif_al_is_n
    Printf_@elsif_al_is_backslash:
      cmp al,'\'
      jne Printf_@endif_al_is_n
      mov bl,[esi]
      mov al,'$'
      mov [esi],al
      mov edx,esi
      dec edx
      mov ah,09h
      int 21h
      mov [esi],bl 
    Printf_@endif_al_is_n:
    mov Printf_lastStrPos_,esi
    add Printf_strPos_,2
    jmp Printf_@loop_next
    Printf_@no_escape_sign:
    inc esi    
    inc Printf_strPos_
    Printf_@loop_next:
    mov al,Printf_strPos_
    cmp al,Printf_strLen_
  jbe Printf_@loop 
  Printf_@done:
  mov eax,Printf_lastStrPos_
  cmp eax,esi
  je Printf_@dont_print_this_3
  mov edx,Printf_lastStrPos_
  mov ah,09h
  int 21h
  Printf_@dont_print_this_3:
  pop es
  ret
Printf ENDP


;[ VOID Puts(DWORD strPtr) ]
Puts PROC
  push es
  mov ax,ds
  mov es,ax
  mov al,'$'
  mov cx,255
  mov edi,Puts_strPtr
  repne scasb
  inc cx
  mov dx,255
  sub dl,cl
  mov Puts_strLen_,dl
  mov esi,Puts_strPtr
  mov Puts_lastStrPos_,esi
  mov Puts_strPos_,1
  Puts_@loop:
    mov al,[esi]
    cmp al,'\'
    jne Puts_@no_escape_sign
    mov al,'$'
    mov [esi],al
    mov eax,esi
    sub eax,Puts_lastStrPos_
    jz Puts_@dont_print_this_2
    mov edx,Puts_lastStrPos_
    mov ah,09h
    int 21h
    Puts_@dont_print_this_2:
    inc esi
    mov al,[esi]
    inc esi
    Puts_@if_al_is_n:
      cmp al,'n'
      jne Puts_@elsif_al_is_backslash
      mov edx,OFFSET sysLF_
      mov ah,09h
      int 21h
      jmp Puts_@endif_al_is_n
    Puts_@elsif_al_is_backslash:
      cmp al,'\'
      jne Puts_@endif_al_is_n
      mov bl,[esi]
      mov al,'$'
      mov [esi],al
      mov edx,esi
      dec edx
      mov ah,09h
      int 21h
      mov [esi],bl 
    Puts_@endif_al_is_n:
    mov Puts_lastStrPos_,esi
    add Puts_strPos_,2
    jmp Puts_@loop_next
    Puts_@no_escape_sign:
    inc esi    
    inc Puts_strPos_
    Puts_@loop_next:
    mov al,Puts_strPos_
    cmp al,Puts_strLen_
  jbe Puts_@loop 
  Puts_@done:
  mov eax,Puts_lastStrPos_
  cmp eax,esi
  je Puts_@dont_print_this_3
  mov edx,Puts_lastStrPos_
  mov ah,09h
  int 21h
  Puts_@dont_print_this_3:
  pop es
  ret
Puts ENDP


;[ VOID Cls() ]
Cls PROC
  mov edi,0b8000h
  mov al,32
  mov ah,TextAttribs_
  mov ecx,2000
  Cls_@loop:
    mov ds:[edi],ax
    add edi,2
    dec cx
  jnz Cls_@loop 
  mov ah,02h
  mov bh,0
  xor dx,dx
  int 10h
  ret
Cls ENDP


;[ VOID TextColor(BYTE color) ]
TextColor PROC
  mov edi,0b8000h
  inc edi
  call GetCursor_
  mov bl,dh
  xor bh,bh
  mov eax,80
  mul bx
  add al,dl
  mov cx,2000
  sub cx,ax  
  shl eax,1
  add edi,eax
  mov al,TextColor_color
  and al,0fh
  and TextAttribs_,0f0h
  or TextAttribs_,al
  mov al,TextAttribs_
  TextColor_@loop:
    mov ds:[edi],al
    add edi,2
    dec cx
  jnz TextColor_@loop
  ret
TextColor ENDP


;[ VOID BkColor(BYTE color) ]
BkColor PROC
  mov edi,0b8000h
  inc edi
  call GetCursor_
  mov bl,dh
  xor bh,bh
  mov eax,80
  mul bx
  add al,dl
  mov cx,2000
  sub cx,ax  
  shl eax,1
  add edi,eax
  mov al,BkColor_color 
  shl al,4
  and TextAttribs_,0fh
  or TextAttribs_,al
  mov al,TextAttribs_
  mov cx,2000
  BkColor_@loop:
    mov ds:[edi],al
    add edi,2
    dec cx
  jnz BkColor_@loop
  ret
BkColor ENDP


;[ VOID TextAttrib(BYTE attrib) ]
TextAttrib PROC
  mov al,TextAttrib_attrib 
  mov edi,0b8000h
  inc edi
  mov cx,2000
  TextAttrib_@loop:
    mov ds:[edi],al
    add edi,2
    dec cx
  jnz TextAttrib_@loop
  ret
TextAttrib ENDP

 
;[ DWORD Input(DWORD maxLen) ]
Input PROC
  mov edx,Input_strPtr_
  mov ecx,Input_maxLen
  mov bx,0
  mov ah,03fh			
  int 21h
  jc Input_@error
  mov _Input,Input_strPtr_
  dec eax
  cmp eax,Input_maxLen
  je Input_@greater_or_equal
  sub Input_maxlen,eax
  mov eax,Input_maxlen
  add _Input,eax
  Input_@greater_or_equal:
  mov BYTE PTR ds:[edx+ecx],36
  jmp Input_@done
  Input_@error:
  mov _Input,0
  Input_@done:
  ret
Input ENDP


Input2 PROC
  mov edi,Input_strPtr_
  Input2_@loop:
    xor eax,eax
    int 16h
    cmp al,0
    je Input2_@loop
    cmp al,13
    je Input2_@return
    mov bh,0
    mov ah,0ah
    mov cx,1
    int 10h
    mov ds:[edi],al
    inc edi
    dec Input_maxLen
  jnz Input2_@loop 
  inc edi
  Input2_@waitForEnter:
    xor eax,eax
    int 16h
    cmp al,13
  jne Input2_@waitForEnter
  Input2_@return:
  mov BYTE PTR ds:[edi],36
  mov _Input,Input_strPtr_
  ret
Input2 ENDP


GetKey PROC
  xor eax,eax
  int 16h
  mov _GetKey,ax
  ret
GetKey ENDP


KbHit PROC
  mov eax,0100h
  int 16h
  jnz KbHit_@not_zero
  mov _KbHit,0
  jmp KbHit_@return
  KbHit_@not_zero:
  mov _KbHit,al
  KbHit_@return:
  ret
KbHit ENDP



;UINT Remainder(UINT x,UINT y)
; parm[eax][ebx]
; value[eax]
Remainder PROC
 cmp eax,ebx
 jng Remainder_@done
 Remainder_@loop:
  sub eax,ebx
  cmp eax,ebx
  jng Remainder_@done
 jmp Remainder_@loop
 Remainder_@done:
 ret
Remainder ENDP


include types.inc

.data
Print_value		dd ?
Print_temp_		dd ?
Print_div_		dd ?
Print_str_		db 11 DUP (?), '$'
Print_subZero_ 		db ?

PrintFloat__value	dd ?
PrintFloat__str_	db 20 DUP (?), '$'
;PrintFloat__str_	db ' %d.%d','$'
PrintFloat__subZero_	db ?
PrintFloat__exp_	db ?
PrintFloat__mantissa_	dd ?
PrintFloat__int_	dd ?
PrintFloat__frac_	dd ?
PrintFloat__fixedFrac_	dd ?
PrintFloat__zeroStr_	db '0.0','$' 
PrintFloat__dot_	db '.$'

PrintHex_value		dd ?
PrintHex_temp_		dd ?
PrintHex_mask_		dd ?
PrintHex_str_		db 10 DUP (?), '$'
PrintHex_subZero_	db ?

PrintBin_value		dd ?
PrintBin_temp_		dd ?
PrintBin_mask_		dd ?
PrintBin_str_		db 33 DUP (?), '$'
PrintBin_subZero_	db ?

Printf_strPtr		dd ?
Printf_params		dd 10 dup (?)	;param 1,2,3..10
Printf_paramPtr_	dd ?
Printf_numParams_	db ?
Printf_strlen_		db ?
Printf_strPos_		db ?
Printf_lastStrPos_	dd ?

Puts_strPtr		dd ?
Puts_strlen_		db ?
Puts_strPos_		db ?
Puts_lastStrPos_	dd ?

TextColor_color		db ?

BkColor_color		db ?

TextAttrib_attrib	db ?

Input_maxLen		dd ?
Input_str_		db 255 dup (?)
Input_strPtr_		equ OFFSET Input_str_
_Input			dd ?

_GetKey			dw ?

_KbHit			db ?
