; Timer routines by Pascal a.k.a. Niklas Beisert
; (slightly) modified by Mic (removed "_":s and compiler directives, added tmSeconds(f))
;
; How to:
; 
;  tmInit	Initialize timer
;  tmGetTimer	Get ...timer..
;  tmClose	Shut down timer 
;  tmSeconds	Convert value from tmGetTimer to seconds
;  tmSecondsf   Same as above but returns a single precicion floating point number
 

tmTimerHandler PROC
 push ds
 mov ds,cs:tmDataSeg
 add ds:tmTicker,65536
 pop ds
 jmp cs:tmOldTimer
tmTimerHandler ENDP


;VOID tmInit(VOID)
tmInit PROC
 mov tmDataSeg,ds
 mov tmTicker,65536
 push es
 mov ax,3508h
 int 21h
 mov dword ptr tmOldTimer+0,ebx
 mov word ptr tmOldTimer+4,es
 pop es
 push ds
 mov ax,2508h
 push cs
 pop ds
 mov edx,OFFSET tmTimerHandler
 int 21h
 pop ds
 mov al,34h
 out 43h,al
 xor al,al
 out 40h,al
 out 40h,al
 ret
tmInit ENDP


;VOID tmClose(VOID)
tmClose PROC
 push ds
 mov ax,2508h
 lds edx,tmOldTimer
 int 21h
 pop ds
 ret
tmClose ENDP


;UINT tmGetTimer(VOID)
; value[eax]
tmGetTimer PROC
 pushf
 cli
 xor eax,eax
 out 43h,al
 in al,40h
 mov ah,al
 in al,40h
 xchg ah,al
 neg eax
 add eax,tmTicker
 popf
 ret
tmGetTimer ENDP


;UINT tmSeconds(UINT ticks)
; parm[eax]
; value[eax]
tmSeconds PROC
 mov tmSt2,eax
 fild dword ptr [tmSt2]
 fld dword ptr [tmSt]
 fdiv
 fistp dword ptr [tmSt2]
 mov eax,tmSt2
 ret
tmSeconds ENDP


;SINGLE tmSecondsf(UINT ticks)
; parm[eax]
; value[eax]
tmSecondsf PROC
 mov tmSt2,eax
 fild dword ptr [tmSt2]
 fld dword ptr [tmSt]
 fdiv
 fstp dword ptr [tmSt2]
 mov eax,tmSt2
 ret
tmSecondsf ENDP


.data
  tmOldTimer	df 0
  tmDataSeg	dw 0
  tmTicker	dd 0
  tmSt		dd 1193046.0	;(extra FPU "register")
  tmSt2		dd ?		;(..another one)
		